'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash.debounce');

var _lodash2 = _interopRequireDefault(_lodash);

var _typeahead = require('../../src/typeahead');

var _typeahead2 = _interopRequireDefault(_typeahead);

var _input = require('./input');

var _input2 = _interopRequireDefault(_input);

var _options = require('./options');

var _options2 = _interopRequireDefault(_options);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TypeaheadWikipedia = function (_React$Component) {
  _inherits(TypeaheadWikipedia, _React$Component);

  function TypeaheadWikipedia(props) {
    _classCallCheck(this, TypeaheadWikipedia);

    var _this = _possibleConstructorReturn(this, (TypeaheadWikipedia.__proto__ || Object.getPrototypeOf(TypeaheadWikipedia)).call(this, props));

    _this.state = {
      inputValue: '',
      options: [],
      numberOfOptions: 0,
      ariaLiveText: ''
    };

    window.parseResponse = function (response) {
      var titles = [];
      if (response && response.query && response.query.pages) {
        var pages = response.query.pages;

        for (var key in pages) {
          if ({}.hasOwnProperty.call(pages, key)) {
            titles.push(pages[key].title);
          }
        }
      }

      var ariaLiveText = titles.length ? titles.length + ' suggestions available. Use up and down keys to navigate followed by enter to select' : 'No suggestions available.';

      this.setState({
        options: titles,
        numberOfOptions: titles.length,
        ariaLiveText: ariaLiveText
      });
    }.bind(_this);

    _this.fetchOptions = (0, _lodash2.default)(_this.fetchOptions.bind(_this), 300);
    _this.onChange = _this.onChange.bind(_this);
    _this.onSelect = _this.onSelect.bind(_this);
    return _this;
  }

  _createClass(TypeaheadWikipedia, [{
    key: 'addScript',
    value: function addScript(src) {
      var s = document.createElement('script');
      s.setAttribute('src', src);
      document.body.appendChild(s);
    }
  }, {
    key: 'fetchOptions',
    value: function fetchOptions(query) {
      this.addScript('https://en.wikipedia.org/w/api.php?action=query&format=json&generator=prefixsearch&gpssearch=' + query + '&gpslimit=10&callback=parseResponse');
    }
  }, {
    key: 'onSelect',
    value: function onSelect(e, selectedindex) {
      var inputValue = e ? e.target.innerHTML : this.state.options[selectedindex];
      this.setState(function () {
        return {
          inputValue: inputValue,
          ariaLiveText: ''
        };
      });
    }
  }, {
    key: 'onChange',
    value: function onChange(e) {
      this.setState({
        ariaLiveText: '',
        inputValue: e.target.value
      });

      this.fetchOptions(e.target.value || '');
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { className: 'Pos(r) W(100%)' },
        _react2.default.createElement(
          _typeahead2.default,
          {
            namespace: 'wikipedia-typeahead',
            numberOfOptions: this.state.numberOfOptions,
            ariaLiveText: this.state.ariaLiveText,
            onSelect: this.onSelect
          },
          _react2.default.createElement(_input2.default, {
            placeholder: 'Wikipedia search',
            value: this.state.inputValue,
            onChange: this.onChange
          }),
          _react2.default.createElement(_options2.default, { options: this.state.options })
        )
      );
    }
  }]);

  return TypeaheadWikipedia;
}(_react2.default.Component);

exports.default = TypeaheadWikipedia;