'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _typeaheadWikipedia = require('./components/typeahead-wikipedia');

var _typeaheadWikipedia2 = _interopRequireDefault(_typeaheadWikipedia);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var HackAtomizer = function HackAtomizer() {
  // eslint-disable-line no-unused-vars
  return _react2.default.createElement('body', { className: 'W(90%) W(720px)--lg  M(a) Ff(ss) Fw(300) Fz(16px) Pos(r)' });
};

var Usage = function Usage() {
  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(
      'h2',
      { className: 'Mt(24px) Fw(300) Fw(700)--lg' },
      'Usage:'
    ),
    _react2.default.createElement(
      'pre',
      { className: 'Ov(s) Mah(300px) Mah(500px)--lg' },
      _react2.default.createElement(
        'code',
        { className: 'language-js' },
        '\nimport React from \'react\';\nimport Typeahead from \'react-accessible-typeahead\';\nimport Input from \'./input\';\nimport Options from \'./options\';\n\nclass MyTypeahead extends React.Component {\n  constructor(props) {\n    super(props);\n    this.state = {\n      inputValue: \'\',\n      options: [],\n      numberOfOptions: 0\n    };\n\n    this.fetchOptions = fetchOptions.bind(this);\n    this.onSelect = this.onSelect.bind(this);\n    this.onChange = this.onChange.bind(this);\n  }\n\n  fetchOptions(query) {\n    this.setState({\n      // some function to fetch option that can be accessed here\n      // options: functionToFetchOption(query)\n    });\n  }\n\n  onSelect(selectedindex) {\n    this.setState(prevState => ({\n      inputValue: e ? e.target.innerHTML : prevState.options[selectedindex]\n    }));\n  }\n\n  onChange(e) {\n    this.setState({\n      inputValue: e.target.value\n    });\n\n    this.fetchOptions(e.target.value || \'\');\n  }\n\n  render() {\n    return (\n      <div className="Pos(a) W(100%)">\n        <Typeahead\n          namespace="my-typeahead"\n          numberOfOptions={this.state.numberOfOptions}\n\n          onSelect={this.onSelect}\n        >\n          <Input\n            placeholder="Search"\n            value={this.state.inputValue}\n            onChange={this.onChange}\n\n          />\n          <Options options={this.state.options}/>\n        </Typeahead>\n      </div>\n    );\n  }\n}\n\nReactDOM.render(\n  <MyTypeAhead/>,\n  document.getElementById(\'root\')\n);\n        '
      )
    )
  );
};

var Header = function Header() {
  return _react2.default.createElement(
    'header',
    null,
    _react2.default.createElement(
      'h1',
      { className: 'Fw(300) Fw(700)--lg Fz(1.75em) Fz(2em)--lg ' },
      _react2.default.createElement(
        'a',
        { href: 'https://github.com/sarbbottam/react-accessible-typeahead/', className: 'Td(n) C(#198fff) D(f) Fld(c) Fld(r)--lg  Jc(sb) Ai(fs) Ai(c)--lg' },
        _react2.default.createElement('img', { src: 'logo.png', alt: '', className: 'Mt(8px) Mstart(-8px) H(80px)' }),
        _react2.default.createElement(
          'span',
          null,
          'react-accessible-typeahead'
        )
      )
    )
  );
};

var Footer = function Footer() {
  return _react2.default.createElement(
    'footer',
    { className: 'Bxz(bb) Pos(f) B(0) Py(16px) Bg(#fff) W(100%) Fw(500) C(#888)' },
    _react2.default.createElement(
      'span',
      null,
      'Built with \u2661 by '
    ),
    _react2.default.createElement(
      'a',
      { className: 'C(#198fff) Td(n)', href: 'https://twitter.com/sarbbottam' },
      '@sarbbottam'
    )
  );
};

var Shell = function Shell() {
  return _react2.default.createElement(
    'div',
    { className: '' },
    _react2.default.createElement(Header, null),
    _react2.default.createElement(_typeaheadWikipedia2.default, null),
    _react2.default.createElement(Usage, null),
    _react2.default.createElement(Footer, null)
  );
};

_reactDom2.default.render(_react2.default.createElement(Shell, null), document.getElementById('root'));