'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TypeAhead = function (_React$Component) {
  _inherits(TypeAhead, _React$Component);

  function TypeAhead(props) {
    _classCallCheck(this, TypeAhead);

    var _this = _possibleConstructorReturn(this, (TypeAhead.__proto__ || Object.getPrototypeOf(TypeAhead)).call(this, props));

    _this.state = {
      shouldOptionsBeVisible: false,
      selectedindex: -1
    };

    _this.showOptions = _this.showOptions.bind(_this);
    _this.hideOptions = _this.hideOptions.bind(_this);

    _this.onFocus = _this.onFocus.bind(_this);
    _this.onBlur = _this.onBlur.bind(_this);
    _this.onChange = _this.onChange.bind(_this);
    _this.onKeyDown = _this.onKeyDown.bind(_this);
    _this.onMouseDown = _this.onMouseDown.bind(_this);
    _this.onMouseOver = _this.onMouseOver.bind(_this);

    _this.onSelect = _this.onSelect.bind(_this);
    return _this;
  }

  _createClass(TypeAhead, [{
    key: 'showOptions',
    value: function showOptions() {
      this.setState({
        shouldOptionsBeVisible: true
      });
    }
  }, {
    key: 'hideOptions',
    value: function hideOptions() {
      this.setState({
        selectedindex: -1,
        shouldOptionsBeVisible: false
      });
    }
  }, {
    key: 'onFocus',
    value: function onFocus(e) {
      /* istanbul ignore else */
      if (this.props.children[0].props.onFocus) {
        this.props.children[0].props.onFocus(e);
      }
      this.showOptions();
    }
  }, {
    key: 'onBlur',
    value: function onBlur(e) {
      /* istanbul ignore else */
      if (this.props.children[0].props.onBlur) {
        this.props.children[0].props.onBlur(e);
      }
      this.hideOptions();
    }
  }, {
    key: 'onChange',
    value: function onChange(e) {
      /* istanbul ignore else */
      if (this.props.children[0].props.onChange) {
        this.props.children[0].props.onChange(e);
      }
      this.showOptions();
    }
  }, {
    key: 'onKeyDown',
    value: function onKeyDown(e) {
      /* istanbul ignore else */
      if (this.props.children[0].props.onKeyDown) {
        this.props.children[0].props.onKeyDown(e);
      }
      if (e.keyCode !== 13 && e.keyCode !== 27 && e.keyCode !== 38 && e.keyCode !== 40) {
        this.setState({
          selectedindex: -1
        });
        return;
      }

      e.preventDefault();

      if (e.keyCode === 27) {
        this.hideOptions();
        return;
      }

      if (e.keyCode === 13) {
        this.onSelect(null, this.state.selectedindex);
        return;
      }

      var selectedindex = void 0;

      if (e.keyCode === 38) {
        selectedindex = this.state.selectedindex - 1;
        if (selectedindex < 0) {
          selectedindex = this.props.numberOfOptions - 1;
        }
      }

      if (e.keyCode === 40) {
        selectedindex = this.state.selectedindex + 1;
        if (selectedindex > this.props.numberOfOptions - 1) {
          selectedindex = 0;
        }
      }

      this.setState({
        shouldOptionsBeVisible: true,
        selectedindex: selectedindex
      });
    }
  }, {
    key: 'onMouseDown',
    value: function onMouseDown(e) {
      /* istanbul ignore else */
      if (this.props.children[1].props.onMouseDown) {
        this.props.children[1].props.onMouseDown(e);
      }
      e.preventDefault();
      this.onSelect(e);
    }
  }, {
    key: 'onMouseOver',
    value: function onMouseOver(e) {
      /* istanbul ignore else */
      if (this.props.children[1].props.onMouseOver) {
        this.props.children[1].props.onMouseOver(e);
      }

      var selectedindex = [].concat(_toConsumableArray(e.target.parentNode.children)).indexOf(e.target);
      this.setState({
        selectedindex: selectedindex
      });
    }
  }, {
    key: 'onSelect',
    value: function onSelect(e, selectedindex) {
      this.props.onSelect(e, selectedindex);

      this.setState({
        selectedindex: -1,
        shouldOptionsBeVisible: false
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var numberOfOptions = this.props.numberOfOptions;

      var inputId = this.props.namespace + '-input';
      var optionsId = this.props.namespace + '-options';

      var Input = _react2.default.cloneElement(this.props.children[0], {
        id: inputId,
        autoComplete: 'off',
        'aria-autocomplete': 'list',
        // Safari needs this
        'aria-controls': optionsId,
        'aria-activedescendant': this.props.namespace + '-' + this.state.selectedindex,

        onFocus: this.onFocus,
        onBlur: this.onBlur,
        onChange: this.onChange,
        onKeyDown: this.onKeyDown

      });

      var Options = _react2.default.cloneElement(this.props.children[1], {
        id: optionsId,
        role: 'listbox',
        namespace: this.props.namespace,
        onMouseDown: this.onMouseDown,
        onMouseOver: this.onMouseOver,
        selectedindex: this.state.selectedindex,
        style: { display: numberOfOptions && this.state.shouldOptionsBeVisible ? 'block' : 'none' }
      });

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'div',
          { className: 'Hidden', role: 'alert' },
          this.props.ariaLiveText
        ),
        _react2.default.createElement(
          'div',
          {
            role: 'combobox',
            'aria-owns': optionsId,
            'aria-haspopup': 'listbox',
            'aria-expanded': numberOfOptions && this.state.shouldOptionsBeVisible
          },
          Input
        ),
        Options
      );
    }
  }]);

  return TypeAhead;
}(_react2.default.Component);

TypeAhead.propTypes = {
  onSelect: _propTypes2.default.func.isRequired,

  namespace: _propTypes2.default.string.isRequired,
  children: _propTypes2.default.array.isRequired,
  numberOfOptions: _propTypes2.default.number.isRequired,
  ariaLiveText: _propTypes2.default.string.isRequired
};

exports.default = TypeAhead;